/*
 * GestioninterventionsApplicationBehavior.java
 * Copyright (c) 2011, W4.
 * All rights reserved.
 */

package GestionInterventions.behavior;

import java.util.ArrayList;

import leon.app.LyApplication;
import leon.app.behaviorinterface.LyApplicationBehaviorInterface;
import leon.data.LyObject;
import leon.data.LyPageWorkSpace;
import leon.data.LyValueSet;
import leon.info.LyClassInfo;
import GestionInterventions.src.GESTIONINTERVENTIONS;
import eu.w4.leon.appmodel.appdefault.behavior.W4ApplicationBehavior;

/**
 * Default implementation of the LyApplicationBehavior.
 * 
 * @see LyApplicationBehaviorInterface
 * @see LyApplication
 */
public class GestioninterventionsApplicationBehavior extends
W4ApplicationBehavior {
  
  static
  {
    LyPageWorkSpace.DEFAULT_LIMIT = 100;
  }
  
	/**
	 * Constructor.
	 * 
	 * @see eu.w4.leon.appmodel.appdefault.behavior.W4ApplicationBehavior#W4ApplicationBehavior
	 */
	public GestioninterventionsApplicationBehavior() {
		super();
	}


	public boolean started(LyApplication application) {
		
		ArrayList<String> months = new ArrayList<String>();
		String monthValue;

		LyClassInfo yearClassInfo = application.getClassInfo(GESTIONINTERVENTIONS.CLS_YEAR_CLASS);
		LyClassInfo monthClassInfo = application.getClassInfo(GESTIONINTERVENTIONS.CLS_MONTH_CLASS);
		LyObject newObjectYear, newObjectMonth = null;
		LyValueSet objectValuesYear, objectValuesMonth =null; 

		for (int i=113; i<115; i++)
		{
			objectValuesYear = new LyValueSet(); 
			objectValuesYear.addValue(yearClassInfo.getFieldInfo(GESTIONINTERVENTIONS.FLD_YEAR_ID), i);
			int year = i+1900; 
			objectValuesYear.addValue(yearClassInfo.getFieldInfo(GESTIONINTERVENTIONS.FLD_YEAR_NAME), "Anne "+year);

			newObjectYear = yearClassInfo.createInstance();
			newObjectYear.setValues(objectValuesYear); 
			newObjectYear.create();

			for (int j=0; j<12; j++)
			{
				objectValuesMonth = new LyValueSet(); 
				objectValuesMonth.addValue(monthClassInfo.getFieldInfo(GESTIONINTERVENTIONS.FLD_MONTH_ID), i+"-"+j);
				objectValuesMonth.addValue(monthClassInfo.getFieldInfo(GESTIONINTERVENTIONS.FLD_MONTH_RELATION_YEAR), newObjectYear.getObjectId());

				int month = j+1; 
				monthValue = month+"-"+year;
				if (month<10)
				{
					monthValue = "0" + monthValue;
				}
				
				objectValuesMonth.addValue(monthClassInfo.getFieldInfo(GESTIONINTERVENTIONS.FLD_MONTH_NAME), monthValue);
				months.add(monthValue);

				newObjectMonth = monthClassInfo.createInstance();
				newObjectMonth.setValues(objectValuesMonth); 
				newObjectMonth.create();
			}  
		}
		
		return super.start(application);
	}
}
